<?php

define('AJAXY_UM_CLIENT_KEY', '56d4131a60f6c8.69447567');
define('AJAXY_UM_LICENSE_SERVER_URL', 'https://www.ajaxy.org');
define('AJAXY_UM_ITEM_REFERENCE', 'UM-AJAX');

class Ajaxy_UM_Forms_License
{
    public $lic;
    public $server = AJAXY_UM_LICENSE_SERVER_URL;
    public $api_key = AJAXY_UM_CLIENT_KEY;
    private $wp_option  = '_ajaxy_um_forms_license';
    private $product_id = 'UM-AJAX';
    public $err;

    public function __construct()
    {
    }
    /**
     * check for current product if licensed
     * @return boolean
     */
    public function is_licensed()
    {
        $lic = get_option($this->wp_option);
        if (!empty($lic)) {
            return true;
        }
        return false;
    }

    /**
     * send query to server and try to active lisence
     * @return boolean
     */
    public function active($key)
    {
        $url = AJAXY_UM_LICENSE_SERVER_URL . '/?secret_key=' . AJAXY_UM_CLIENT_KEY . '&slm_action=slm_activate&license_key=' . $key . '&registered_domain=' . get_bloginfo('url').'&item_reference='.$this->product_id;
        $response = wp_remote_get($url, array('timeout' => 20, 'sslverify' => false));
        $license_data = null;
        if (is_array($response)) {
            $json = $response['body']; // use the content
            $json = preg_replace('/[\x00-\x1F\x80-\xFF]/', '', utf8_encode($json));
            $license_data = json_decode($json);
        }
        if ($license_data && $license_data->result == 'success') {
            update_option($this->wp_option, $key);
            return true;
        } else {
            delete_option($this->wp_option);
            return $license_data->message;
        }
    }
}
global $Ajaxy_UM_Forms_License;
$Ajaxy_UM_Forms_License = new Ajaxy_UM_Forms_License();
