<?php

    /***
	***	@login checks thru the frontend login
	***/
	add_action('um_ajax_submit_form_errors_hook_logincheck', 'um_ajax_submit_form_errors_hook_logincheck', 9999 );
    function um_ajax_submit_form_errors_hook_logincheck($args)
    {
        $json = array('status' => 'error', 'message' => '', 'redirect' => false);
        if(UM()->form()->errors){
            wp_die(wp_json_encode(
                array_replace($json, array(
                    'status' => 'error',
                    'message' => UM()->form()->errors,
                    'redirect' => false
                ))
            ));
        }
		// Logout if logged in
		if ( is_user_logged_in() ) {
			wp_logout();
		}
		$user_id = ( isset( UM()->login()->auth_id ) ) ? UM()->login()->auth_id : '';
		um_fetch_user( $user_id );

        $status = um_user('account_status'); // account status
        switch ($status) {
            // If user can't login to site...
            case 'inactive':
            case 'awaiting_admin_review':
            case 'awaiting_email_confirmation':
            case 'rejected':
                um_reset_user();
                if (! UM()->form()->has_error($status)) {
                    UM()->form()->add_error($status, um_return_update_notice($status, true));
                }
                wp_die(wp_json_encode(
                    array_replace($json, array(
                        'status' => 'error',
                        'message' => UM()->form()->errors,
                        'redirect' => false
                    ))
                ));
                break;
        }
    }
    /***
    ***	@login user
    ***/
    add_action('um_ajax_user_login', 'um_ajax_user_login', 10);
    function um_ajax_user_login($args)
    {
		extract( $args );
		$rememberme = ( isset( $args['rememberme'] ) && 1 ==  $args['rememberme']  && isset( $_REQUEST['rememberme'] ) ) ? 1 : 0;

        $json = array('status' => 'error', 'message' => '', 'redirect' => false);

        if (( UM()->options()->get('deny_admin_frontend_login')   && ! isset( $_GET['provider'] ) ) && strrpos( um_user('wp_roles' ), 'administrator' ) !== false) {
            wp_die(wp_json_encode(
                array_replace($json, array(
                    'status' => 'error',
                    'message' => __('This action has been prevented for security measures.', 'ultimate-member'),
                    'redirect' => false
                ))
            ));
        }
        UM()->user()->auto_login( um_user('ID'), $rememberme );
		// Hook that runs after successful login and before user is redirected
		do_action('um_on_login_before_redirect', um_user('ID') );

        // Priority redirect
        if (isset($args['redirect_to']) && ! empty($args['redirect_to'])) {
            wp_die(wp_json_encode(
                array_replace($json, array(
                    'status' => 'success',
                    'message' => um_return_update_notice('login_redirect', false),
                    'redirect' => $args['redirect_to']
                ))
            ));
        }

        $role = um_user('role');
		$role_data = UM()->roles()->role_data( $role );

        $redirect = '';
        // Role redirect
        if (empty($role_data['after_login'])) {
            $redirect = um_user_profile_url();
        } else {
            switch ($role_data['after_login']) {
                case 'redirect_admin':
                    $redirect = admin_url();
                    break;

                case 'redirect_url':
                    $redirect = $role_data['login_redirect_url'];
                    break;

                case 'refresh':
                    $url  = isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER']: um_get_option('core_login');
                    $redirect = $url;
                    break;

                case 'redirect_profile':
                default:
                    $redirect = um_user_profile_url();
                    break;

            }
        }
        wp_die(wp_json_encode(
            array_replace($json, array(
                'status' => 'success',
                'message' => um_return_update_notice($role_data['after_login'], false),
                'redirect' => $redirect
            ))
        ));
    }

    /***
    ***	@form processing
    ***/
    function um_ajax_submit_form_login($args)
    {
        if (!isset(UM()->form()->errors)) {
            do_action('um_ajax_user_login', $args);
        }
        do_action('um_ajax_user_login_extra_hook', $args);
    }
