<?php
    /***
    ***	@add a notice to form
    ***/

    remove_action('um_before_form', 'um_add_update_notice', 500);

    function um_return_update_notice($status, $is_error = false)
    {
        $err        = '';
        $success    = '';

        if (!$is_error) {
            switch ($status) {
                default:
                    $success = apply_filters("um_custom_success_message_handler", $success, $status);
                    break;

                case 'account':
                    $success = __('Your account was updated successfully.', 'ultimate-member');
                    break;

                case 'password_changed':
                    $success = __('You have successfully changed your password.', 'ultimate-member');
                    break;

                case 'account_active':
                    $success = __('Your account is now active! You can login.', 'ultimate-member');
                    break;

            }
            return $success;
        }
        switch ($status) {
            default:
                $err = apply_filters("um_custom_error_message_handler", $err, $status);
                if (!$err) {
                    $err = __('An error has been encountered', 'ultimate-member');
                }
                break;

            case 'registration_disabled':
                $err = __('Registration is currently disabled', 'ultimate-member');
                break;

            case 'blocked_email':
                $err = __('This email address has been blocked.', 'ultimate-member');
                break;

            case 'blocked_domain':
                $err = __('We do not accept registrations from that domain.', 'ultimate-member');
                break;

            case 'blocked_ip':
                $err = __('Your IP address has been blocked.', 'ultimate-member');
                break;

            case 'inactive':
                $err = __('Your account has been disabled.', 'ultimate-member');
                break;

            case 'awaiting_admin_review':
                $err = __('Your account has not been approved yet.', 'ultimate-member');
                break;

            case 'awaiting_email_confirmation':
                $err = __('Your account is awaiting e-mail verification.', 'ultimate-member');
                break;

            case 'rejected':
                $err = __('Your membership request has been rejected.', 'ultimate-member');
                break;

        }
        return $err;
    }
