<?php

/**
 * Add user to wordpress
 */
add_action('um_ajax_add_user_frontend', 'um_ajax_add_user_frontend', 10);
function um_ajax_add_user_frontend($args){

	unset( $args['user_id'] );

	extract($args);


	if ( isset( $username ) && !isset($args['user_login']) ) {
		$user_login = $username;
	}

	if ( ! empty( $first_name ) &&  ! empty( $last_name ) && ! isset( $user_login ) ) {

		if ( um_get_option('permalink_base') == 'name' ) {
			$user_login = rawurlencode( strtolower( str_replace(" ",".",$first_name." ".$last_name ) ) );
		}else if ( um_get_option('permalink_base') == 'name_dash' ) {
			$user_login = rawurlencode( strtolower( str_replace(" ","-",$first_name." ".$last_name ) ) );
		}else if ( um_get_option('permalink_base') == 'name_plus' ) {
			$user_login = strtolower( str_replace(" ","+",$first_name." ".$last_name ) );
		}else{
			$user_login = strtolower( str_replace(" ","",$first_name." ".$last_name ) );
		}

		// if full name exists
		$count = 1;
		while( username_exists( $user_login ) ) {
			$user_login .= $count;
			$count++;
		}
	}

	if( !isset( $user_login ) && isset( $user_email ) && $user_email )
	{
		$user_login = $user_email;
	}

	$unique_userID = UM()->query()->count_users() + 1;

	if ( ! isset( $user_login ) ||  strlen( $user_login ) > 30 && ! is_email( $user_login ) ) {
		$user_login = 'user' . $unique_userID;
	}

	if ( isset( $username ) && is_email( $username ) ) {
		$user_email = $username;
	}

	if ( ! isset( $user_password ) ){
		$user_password = UM()->validation()->generate( 8 );
	}


	if( ! isset( $user_email ) ) {
		$site_url = @$_SERVER['SERVER_NAME'];
		$user_email = 'nobody' . $unique_userID . '@' . $site_url;
		$user_email = apply_filters("um_user_register_submitted__email", $user_email );
	}


	$creds['user_login'] = $user_login;
	$creds['user_password'] = $user_password;
	$creds['user_email'] = trim( $user_email );

	$args = apply_filters('um_add_user_frontend_submitted', $args );

	$args['submitted'] = array_merge( $args['submitted'], $creds);
	$args = array_merge($args, $creds);

	unset( $args['user_id'] );


	do_action('um_before_new_user_register', $args);

	$user_id = wp_create_user( $user_login, $user_password, $user_email );

	do_action('um_ajax_after_new_user_register', $user_id, $args);

	return $user_id;
}

/**
 * After adding a new user
 */
 add_action('um_ajax_after_new_user_register', 'um_ajax_after_new_user_register', 10, 2);
function um_ajax_after_new_user_register( $user_id, $args ){
	global $pagenow;
	extract( $args );

	um_fetch_user( $user_id );

	if ( !isset( $args['role'] ) ) {
		$role = um_get_option('default_role');
	}

	if ( $pagenow != 'user-new.php' && !array_key_exists( $role, UM()->roles()->get_roles( false, array('admin') ) ) ) {
		$role = um_get_option('default_role');
	}

	UM()->roles()->set_role($user_id, $role );

	UM()->user()->set_registration_details( $args['submitted'] );

	UM()->user()->set_last_login();

	do_action('um_new_user_registration_plain');

	do_action('um_post_registration_save', $user_id, $args);

	do_action('um_post_registration_listener', $user_id, $args);

	do_action('um_update_profile_full_name', $args );

	do_action('um_ajax_post_registration', $user_id, $args);

	if( ! is_admin() ){
		do_action('user_register', $user_id );
	}

}
/**
 * Post-registration procedure
 */
 add_action('um_ajax_post_registration', 'um_ajax_post_registration', 10, 2);
function um_ajax_post_registration( $user_id, $args ){
	unset(  $args['user_id'] );
	extract($args);

    $status = um_user('status');

	do_action("um_post_registration_global_hook", $user_id, $args);

	do_action("um_post_registration_{$status}_hook", $user_id, $args);

	if ( true ) {

		do_action("track_{$status}_user_registration");
		$json = array('status' => 'error', 'message' => '', 'redirect' => false);
		// Priority redirect
		if ( isset( $args['redirect_to'] ) ) {
            wp_die(wp_json_encode(
                array_replace($json, array(
                    'status' => 'success',
                    'message' => '',
                    'redirect' => urldecode( $args['redirect_to'] )
                ))
            ));
		}

        if ( $status == 'approved' ) {


			UM()->user()->auto_login( $user_id );

			do_action('um_registration_after_auto_login', $user_id );

			if ( um_user('auto_approve_act') == 'redirect_url' && um_user('auto_approve_url') !== '' ){
				wp_die(wp_json_encode(
	                array_replace($json, array(
	                    'status' => 'success',
	                    'message' => '',
	                    'redirect' => um_user('auto_approve_url')
	                ))
	            ));
			}
			if ( um_user('auto_approve_act') == 'redirect_profile' ){
				wp_die(wp_json_encode(
	                array_replace($json, array(
	                    'status' => 'success',
	                    'message' => '',
	                    'redirect' => um_user_profile_url()
	                ))
	            ));
			}

		}

		if ( $status != 'approved' ) {

			if ( um_user( $status . '_action' ) == 'redirect_url' && um_user( $status . '_url' ) != '' ) {
				wp_die(wp_json_encode(
	                array_replace($json, array(
	                    'status' => 'success',
	                    'message' => '',
	                    'redirect' => um_user( $status . '_url' )
	                ))
	            ));
			}

			if ( um_user( $status . '_action' ) == 'show_message' && um_user( $status . '_message' ) != '' ) {

				$role_id = UM()->roles()->get_role_name( um_user('role'), true );
				$url  = isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER']: um_get_option('core_register');
				$url  = add_query_arg( 'message', esc_attr( $status ), $url );
				$url  = add_query_arg( 'um_role', esc_attr( $role_id ), $url );
				$url  = add_query_arg( 'um_form_id', esc_attr( $form_id ), $url );

				wp_die(wp_json_encode(
	                array_replace($json, array(
	                    'status' => 'success',
	                    'message' => um_user( $status . '_message' )
	                ))
	            ));
			}


		}

	}

}
add_action('um_ajax_user_registration', 'um_ajax_user_registration', 10);
function um_ajax_user_registration($args){
    unset( $args['user_id'] );
	do_action('um_ajax_add_user_frontend', $args);

}

/**
 * Form Processing
 */
function um_ajax_submit_form_register($args){
	if ( !isset(UM()->form()->errors) ) {
		do_action('um_ajax_user_registration', $args);
	}else{
		$json = array('status' => 'error', 'message' => '', 'redirect' => false);
		wp_die(wp_json_encode(
			array_replace($json, array(
				'status' => 'error',
				'message' => UM()->form()->errors,
				'redirect' => false
			))
		));
	}

	do_action('um_user_registration_extra_hook', $args );

}
