jQuery(document).ready(function() {
    if (typeof(um_ajax) != "undefined") {
        jQuery(um_ajax.forms).on("submit", "form", function(event) {
            event.preventDefault();
            var form = jQuery(this);
            var data = form.serializeArray(); // convert form to array
            data.push({
                name: "action",
                value: "um_submit_form"
            });

            form.find('.um-field-error').remove();
            form.find('.um-notice').remove();
            form.addClass("um-loading");

            jQuery.post(um_ajax.endpoint, data, function(resp) {
                var status = '';
                if (resp.status != "success") {
                    if (resp.status == "submit") {
                        jQuery(event.delegateTarget).unbind("submit");
                        // form.unbind().submit();
                        if(resp.message){
                            jQuery('<p class="um-notice err"><i class="um-icon-ios-close-empty" onclick="jQuery(this).parent().fadeOut();"></i> '+resp.message+'</p>').prependTo(form);
                        }
                        return true;
                    }
                    if (resp.nonce) {
                        form.find('#_wpnonce').val(resp.nonce);
                    }
                    status = 'err';
                } else {
                    status = 'success';
                    if (resp.redirect) {
                        window.location.href = resp.redirect;
                        return true;
                    }
                }
                if(!resp.message){
                    return;
                }
                if (typeof resp.message === 'object' || jQuery.isArray(resp.message)) {
                    if (status == 'err') {
                        jQuery.each(resp.message, function(index, value) {
                            if (jQuery('.um-field-' + index).length > 0) {
                                jQuery('.um-field-' + index).append('<div class="um-field-error"><span class="um-field-arrow"><i class="um-faicon-caret-up"></i></span>' + value + '</div>');
                            } else {
                                jQuery('<p class="um-notice ' + status + '"><i class="um-icon-ios-close-empty" onclick="jQuery(this).parent().fadeOut();"></i>' + value + '</p>').prependTo(form);
                            }
                        });
                    } else {
                        jQuery.each(resp.message, function(index, value) {
                            jQuery('<p class="um-notice ' + status + '"><i class="um-icon-ios-close-empty" onclick="jQuery(this).parent().fadeOut();"></i>' + value + '</p>').prependTo(form);
                        });
                    }
                } else {
                    jQuery('<p class="um-notice ' + status + '"><i class="um-icon-ios-close-empty" onclick="jQuery(this).parent().fadeOut();"></i>' + resp.message +
                        '</p>').prependTo(form);
                }

            }, "json").always(function() {
                form.removeClass("um-loading");
                form.find('.um-button[type="submit"]').removeAttr("disabled");
            });
            return false;
        });
    }
});
